﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Printing;
using System.IO;
namespace WPrintRel
{
 public partial class Form1 : Form
 {
  private Font Fonte;
  private StreamReader Leitor;
  private OpenFileDialog CaixaDlg1;
  private PrintDocument PD = new PrintDocument();
  private PageSettings ConfigPag = new PageSettings();
  public Form1()
  {
   // Adiciona o manipulador de evento Imprime à
   // lista de manipuladores de eventos
   PD.PrintPage += new PrintPageEventHandler(this.Imprime);
   InitializeComponent();
  }
  // Botão Imprimir
  private void button1_Click(object sender,EventArgs e)
  {
   CaixaDlg1 = new OpenFileDialog();
   CaixaDlg1.Title = "Escolha um arquivo";
   CaixaDlg1.Filter = "Arquivos-texto (*.txt)|*.txt";
   if (CaixaDlg1.ShowDialog() == DialogResult.Cancel)
      MessageBox.Show("Arquivo não selecionado","Impressão");
   else
      {
       PD.DefaultPageSettings = ConfigPag;
       PrintDialog CaixaDlg2 = new PrintDialog();
       CaixaDlg2.Document = PD;
       if (CaixaDlg2.ShowDialog() == DialogResult.OK)
          {
           Leitor = new StreamReader(CaixaDlg1.FileName);
           Fonte = new Font("Courier New",10);
           PD.Print();     // Chama o método Print()
           Leitor.Close(); // Fecha o objeto StreamReader
          }
      }
  }
  // Método manipulador do evento PrintPage
  private void Imprime(object sender,PrintPageEventArgs e)
  {
   string Lin = null; short CLin = 0;
   float LPPf = 0F; // Linhas  por página
   double LPPd = 0; // Linhas  por página
   float DVf = 0F;  // Deslocamento vertical
   double DVd = 0;  // Deslocamento vertical
   float MargEsq = e.MarginBounds.Left;
   float MargSup = e.MarginBounds.Top;
   // Calcula o número de linhas por página
   LPPf = e.MarginBounds.Height / Fonte.GetHeight(e.Graphics);
   LPPd = LPPf;
   LPPd = Math.Floor(LPPd);
   // Lê cada uma das linhas do arquivo
   while (CLin < LPPd && ((Lin = Leitor.ReadLine()) != null))
   {
    DVf = MargSup + (CLin * Fonte.GetHeight(e.Graphics));
    DVd = DVf;
    DVd = Math.Floor(DVd);
    e.Graphics.DrawString(Lin,Fonte,Brushes.Black,MargEsq,(float)DVd,new StringFormat());
    CLin += 1;
   }
   if (Lin != null)  // Verifica se há mais linhas
       e.HasMorePages = true;
   else
       e.HasMorePages = false;
  }
  // Botão Sair
  private void button2_Click(object sender,EventArgs e)
  {
   Application.Exit();
  }
 }
}
